import React from 'react';
import { OnBackgroundTapGestureEvent, OnCurrentModalConfigDidChangeEvent, OnModalContentInitializedEvent, OnModalDidHideEvent, OnModalDidShowEvent, OnModalDidSnapEvent, OnModalDismissCancelledEvent, OnModalPresentCancelledEvent, OnModalStateWillChangeEvent, OnModalWillHideEvent, OnModalWillShowEvent, OnModalWillSnapEvent, RNIAdaptiveModalCommandConfigDismiss, RNIAdaptiveModalCommandConfigSnapTo, RNIAdaptiveModalCommandConfigSnapToCommon, RNIAdaptiveModalCommandConfigSnapToOverride, RNIAdaptiveModalView } from '../../native_components/RNIAdaptiveModalView';
import type { AdaptiveModalViewProps, AdaptiveModalViewState } from './AdaptiveModalViewTypes';
import { AdaptiveModalEventEmitter } from './AdaptiveModalEventEmitter';
import { RNIAdaptiveModalCommandConfigPresent } from '../../native_components/RNIAdaptiveModalView';
export declare class AdaptiveModalView extends React.PureComponent<AdaptiveModalViewProps, AdaptiveModalViewState> {
    nativeRef: RNIAdaptiveModalView;
    emitter: AdaptiveModalEventEmitter;
    constructor(props: AdaptiveModalViewProps);
    private getProps;
    private mountModalContent;
    notifyDidLayoutSubviews: () => Promise<void>;
    clearSnapPointOverride: () => Promise<void>;
    presentModal: (commandConfig: RNIAdaptiveModalCommandConfigPresent) => Promise<void>;
    dismissModal: (commandConfig: RNIAdaptiveModalCommandConfigDismiss) => Promise<void>;
    snapTo: (commandConfig: RNIAdaptiveModalCommandConfigSnapTo) => Promise<void>;
    snapToOverride: (commandConfig: RNIAdaptiveModalCommandConfigSnapToOverride) => Promise<void>;
    snapToClosestSnapPoint: (commandConfig?: RNIAdaptiveModalCommandConfigSnapToCommon) => Promise<void>;
    snapToPrevSnapPointIndex: (commandConfig?: RNIAdaptiveModalCommandConfigSnapToCommon) => Promise<void>;
    snapToCurrentSnapPointIndex: (commandConfig?: RNIAdaptiveModalCommandConfigSnapToCommon) => Promise<void>;
    snapToNextSnapPointIndex: (commandConfig?: RNIAdaptiveModalCommandConfigSnapToCommon) => Promise<void>;
    _handleOnModalContentDetached: OnModalContentInitializedEvent;
    _handleOnModalWillSnap: OnModalWillSnapEvent;
    _handleOnModalDidSnap: OnModalDidSnapEvent;
    _handleOnModalWillShow: OnModalWillShowEvent;
    _handleOnModalDidShow: OnModalDidShowEvent;
    _handleOnModalWillHide: OnModalWillHideEvent;
    _handleOnModalDidHide: OnModalDidHideEvent;
    _handleOnModalPresentCancelled: OnModalPresentCancelledEvent;
    _handleOnModalDismissCancelled: OnModalDismissCancelledEvent;
    _handleOnCurrentModalConfigDidChange: OnCurrentModalConfigDidChangeEvent;
    _handleOnBackgroundTapGesture: OnBackgroundTapGestureEvent;
    _handleOnModalStateWillChange: OnModalStateWillChangeEvent;
    render(): React.JSX.Element;
}
//# sourceMappingURL=AdaptiveModalView.d.ts.map