import * as React from 'react';
import { View } from 'react-native';
import type { RNIAdaptiveModalViewProps } from './RNIAdaptiveModalViewTypes';
import type { RNIAdaptiveModalCommandConfigPresent } from './RNIAdaptiveModalCommandPresentTypes';
import type { RNIAdaptiveModalCommandConfigDismiss } from './RNIAdaptiveModalCommandConfigDismiss';
import type { RNIAdaptiveModalCommandConfigSnapToCommon } from './RNIAdaptiveModalCommandSnapToCommonTypes';
import type { RNIAdaptiveModalCommandConfigSnapToOverride } from './RNIAdaptiveModalCommandSnapToOverrideTypes';
import type { RNIAdaptiveModalCommandConfigSnapTo } from './RNIAdaptiveModalCommandSnapToTypes';
export declare class RNIAdaptiveModalView extends React.PureComponent<RNIAdaptiveModalViewProps> {
    nativeRef?: View;
    reactTag?: number;
    constructor(props: RNIAdaptiveModalViewProps);
    componentWillUnmount(): void;
    getNativeRef: () => View | undefined;
    getNativeReactTag: () => number | undefined;
    notifyDidLayoutSubviews: () => Promise<void>;
    clearSnapPointOverride: () => Promise<void>;
    presentModal: (commandConfig: RNIAdaptiveModalCommandConfigPresent) => Promise<void>;
    dismissModal: (commandConfig: RNIAdaptiveModalCommandConfigDismiss) => Promise<void>;
    snapTo: (commandConfig: RNIAdaptiveModalCommandConfigSnapTo) => Promise<void>;
    snapToOverride: (commandConfig: RNIAdaptiveModalCommandConfigSnapToOverride) => Promise<void>;
    snapToClosestSnapPoint: (commandConfig?: RNIAdaptiveModalCommandConfigSnapToCommon) => Promise<void>;
    snapToPrevSnapPointIndex: (commandConfig?: RNIAdaptiveModalCommandConfigSnapToCommon) => Promise<void>;
    snapToCurrentSnapPointIndex: (commandConfig?: RNIAdaptiveModalCommandConfigSnapToCommon) => Promise<void>;
    snapToNextSnapPointIndex: (commandConfig?: RNIAdaptiveModalCommandConfigSnapToCommon) => Promise<void>;
    private _handleOnLayout;
    private _handleOnNativeRef;
    render(): React.DetailedReactHTMLElement<React.InputHTMLAttributes<HTMLInputElement>, HTMLInputElement>;
}
//# sourceMappingURL=RNIAdaptiveModalView.d.ts.map